From d78079a3df9fec8e5b7d5ce4dda1e3669c1dee11 Mon Sep 17 00:00:00 2001
From: "Endi S. Dewata" <edewata@redhat.com>
Date: Thu, 1 Aug 2013 11:00:49 -0400
Subject: [PATCH] Reorganized PKIPrincipal.

The PKIPrincipal is in cmscore package but it's needed by the REST
services in cms package so the class has been moved into cms package.
---
 base/common/src/com/netscape/cms/authorization/ACLInterceptor.java      | 2 +-
 .../src/com/netscape/cms/authorization/AuthMethodInterceptor.java       | 2 +-
 base/common/src/com/netscape/{cmscore => cms}/realm/PKIPrincipal.java   | 2 +-
 base/common/src/com/netscape/cms/realm/PKIRealm.java                    | 1 -
 base/common/src/com/netscape/cms/servlet/cert/CertService.java          | 2 +-
 base/common/src/com/netscape/cms/servlet/profile/ProfileService.java    | 2 +-
 base/common/src/com/netscape/cms/servlet/tks/TPSConnectorService.java   | 2 +-
 7 files changed, 6 insertions(+), 7 deletions(-)
 rename base/common/src/com/netscape/{cmscore => cms}/realm/PKIPrincipal.java (94%)

diff --git a/base/common/src/com/netscape/cms/authorization/ACLInterceptor.java b/base/common/src/com/netscape/cms/authorization/ACLInterceptor.java
index 1a3a0975294e219fff8b51dde0a360321e43836d..52d9eb8995a9e6265863bb5d118cf0b4f2a6eb78 100644
--- a/base/common/src/com/netscape/cms/authorization/ACLInterceptor.java
+++ b/base/common/src/com/netscape/cms/authorization/ACLInterceptor.java
@@ -41,7 +41,7 @@ import com.netscape.certsrv.authorization.EAuthzAccessDenied;
 import com.netscape.certsrv.authorization.IAuthzSubsystem;
 import com.netscape.certsrv.base.EBaseException;
 import com.netscape.certsrv.base.ForbiddenException;
-import com.netscape.cmscore.realm.PKIPrincipal;
+import com.netscape.cms.realm.PKIPrincipal;
 
 /**
  * @author Endi S. Dewata
diff --git a/base/common/src/com/netscape/cms/authorization/AuthMethodInterceptor.java b/base/common/src/com/netscape/cms/authorization/AuthMethodInterceptor.java
index 3f47d0c57a1b8622877de75c857ffe1939e6c1e3..c42ba26d0595ddb0d447aaddb849b1df7f018fa6 100644
--- a/base/common/src/com/netscape/cms/authorization/AuthMethodInterceptor.java
+++ b/base/common/src/com/netscape/cms/authorization/AuthMethodInterceptor.java
@@ -40,7 +40,7 @@ import com.netscape.certsrv.authentication.AuthMethodMapping;
 import com.netscape.certsrv.authentication.AuthToken;
 import com.netscape.certsrv.authentication.IAuthToken;
 import com.netscape.certsrv.base.ForbiddenException;
-import com.netscape.cmscore.realm.PKIPrincipal;
+import com.netscape.cms.realm.PKIPrincipal;
 
 /**
  * @author Endi S. Dewata
diff --git a/base/common/src/com/netscape/cmscore/realm/PKIPrincipal.java b/base/common/src/com/netscape/cms/realm/PKIPrincipal.java
similarity index 94%
rename from base/common/src/com/netscape/cmscore/realm/PKIPrincipal.java
rename to base/common/src/com/netscape/cms/realm/PKIPrincipal.java
index 6f806e3e9f79bf96e81317ec57832b9347cab0f5..c39ab4157504e1f6b38c7b170e77829f5f403502 100644
--- a/base/common/src/com/netscape/cmscore/realm/PKIPrincipal.java
+++ b/base/common/src/com/netscape/cms/realm/PKIPrincipal.java
@@ -1,4 +1,4 @@
-package com.netscape.cmscore.realm;
+package com.netscape.cms.realm;
 
 import java.util.List;
 
diff --git a/base/common/src/com/netscape/cms/realm/PKIRealm.java b/base/common/src/com/netscape/cms/realm/PKIRealm.java
index d6ac100f5f023523d182733d6d82136615883690..b035f53f66a4b05eaa4b7d3edfcfed5c9b22169a 100644
--- a/base/common/src/com/netscape/cms/realm/PKIRealm.java
+++ b/base/common/src/com/netscape/cms/realm/PKIRealm.java
@@ -21,7 +21,6 @@ import com.netscape.certsrv.usrgrp.IGroup;
 import com.netscape.certsrv.usrgrp.IUGSubsystem;
 import com.netscape.certsrv.usrgrp.IUser;
 import com.netscape.cms.servlet.common.AuthCredentials;
-import com.netscape.cmscore.realm.PKIPrincipal;
 
 /**
  *  PKI Realm
diff --git a/base/common/src/com/netscape/cms/servlet/cert/CertService.java b/base/common/src/com/netscape/cms/servlet/cert/CertService.java
index 68d218afefe2e7446990585f20a0cd64de18c4f2..6f46d9eb57f5bf7a0a8aee893d3a02a1079ad5c2 100644
--- a/base/common/src/com/netscape/cms/servlet/cert/CertService.java
+++ b/base/common/src/com/netscape/cms/servlet/cert/CertService.java
@@ -75,9 +75,9 @@ import com.netscape.certsrv.dbs.certdb.ICertificateRepository;
 import com.netscape.certsrv.logging.AuditFormat;
 import com.netscape.certsrv.logging.ILogger;
 import com.netscape.certsrv.request.IRequest;
+import com.netscape.cms.realm.PKIPrincipal;
 import com.netscape.cms.servlet.base.PKIService;
 import com.netscape.cms.servlet.processors.Processor;
-import com.netscape.cmscore.realm.PKIPrincipal;
 import com.netscape.cmsutil.ldap.LDAPUtil;
 import com.netscape.cmsutil.util.Utils;
 
diff --git a/base/common/src/com/netscape/cms/servlet/profile/ProfileService.java b/base/common/src/com/netscape/cms/servlet/profile/ProfileService.java
index 3a5e63eee52ab9836e3068fadd283cc9758cac88..edb8b22489fc7ddca3aae59dedcaaa869d75baff 100644
--- a/base/common/src/com/netscape/cms/servlet/profile/ProfileService.java
+++ b/base/common/src/com/netscape/cms/servlet/profile/ProfileService.java
@@ -73,8 +73,8 @@ import com.netscape.certsrv.profile.ProfileResource;
 import com.netscape.certsrv.property.EPropertyException;
 import com.netscape.certsrv.registry.IPluginInfo;
 import com.netscape.certsrv.registry.IPluginRegistry;
+import com.netscape.cms.realm.PKIPrincipal;
 import com.netscape.cms.servlet.base.PKIService;
-import com.netscape.cmscore.realm.PKIPrincipal;
 
 /**
  * @author alee
diff --git a/base/common/src/com/netscape/cms/servlet/tks/TPSConnectorService.java b/base/common/src/com/netscape/cms/servlet/tks/TPSConnectorService.java
index ad00b050a8f9910dcf36591d9d810b1318746104..26f25bd4f2c93bdec9a7e711331f44738910896c 100644
--- a/base/common/src/com/netscape/cms/servlet/tks/TPSConnectorService.java
+++ b/base/common/src/com/netscape/cms/servlet/tks/TPSConnectorService.java
@@ -37,7 +37,7 @@ import com.netscape.certsrv.system.TPSConnectorResource;
 import com.netscape.certsrv.tps.cert.TPSCertResource;
 import com.netscape.certsrv.usrgrp.IUGSubsystem;
 import com.netscape.certsrv.usrgrp.IUser;
-import com.netscape.cmscore.realm.PKIPrincipal;
+import com.netscape.cms.realm.PKIPrincipal;
 import com.netscape.cmsutil.crypto.CryptoUtil;
 import com.netscape.cmsutil.util.Utils;
 
-- 
1.8.1.4