From 93c82381687f96f5e21359770f24fe88cbc69954 Mon Sep 17 00:00:00 2001
From: Matthew Harmsen <mharmsen@redhat.com>
Date: Wed, 9 Jan 2013 17:56:03 -0800
Subject: [PATCH] Added third-party license file

* TRAC Ticket #430 - License for 3rd party code
---
 base/common/THIRD_PARTY_LICENSES | 61 ++++++++++++++++++++++++++++++++++++++++
 specs/pki-core.spec              |  6 +++-
 2 files changed, 66 insertions(+), 1 deletion(-)
 create mode 100644 base/common/THIRD_PARTY_LICENSES

diff --git a/base/common/THIRD_PARTY_LICENSES b/base/common/THIRD_PARTY_LICENSES
new file mode 100644
index 0000000..3749529
--- /dev/null
+++ b/base/common/THIRD_PARTY_LICENSES
@@ -0,0 +1,61 @@
+This file contains a list of third party code which is not under general
+Dogtag copyright.
+
+
+Third party code:
+
+jQuery - licensed under MIT license
+ * jquery-min.js (compressed 'minified' version)
+   Project URL:  http://jquery.com/
+   License URL:  https://github.com/jquery/jquery/blob/master/MIT-LICENSE.txt
+
+jQuery.i18n.properties - dual licensed under MIT and GPL licenses
+ * jquery.i18n.properties-min.js (compressed 'minified' version)
+   Project URL:   http://code.google.com/p/jquery-i18n-properties/
+   License URLS:  http://dev.jquery.com/browser/trunk/jquery/MIT-LICENSE.txt
+                  http://dev.jquery.com/browser/trunk/jquery/GPL-LICENSE.txt
+
+
+
+Full license texts, copyright notices, and headers are listed below.
+
+= jQuery copyright notice with MIT license =
+
+Copyright 2013 jQuery Foundation and other contributors
+http://jquery.com/
+
+Permission is hereby granted, free of charge, to any person obtaining
+a copy of this software and associated documentation files (the
+"Software"), to deal in the Software without restriction, including
+without limitation the rights to use, copy, modify, merge, publish,
+distribute, sublicense, and/or sell copies of the Software, and to
+permit persons to whom the Software is furnished to do so, subject to
+the following conditions:
+
+The above copyright notice and this permission notice shall be
+included in all copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
+LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
+OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
+WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+
+= jQuery.i18n.properties header =
+
+******************************************************************************
+ * jquery.i18n.properties
+ *
+ * Dual licensed under the GPL (http://dev.jquery.com/browser/trunk/jquery/GPL-LICENSE.txt) and
+ * MIT (http://dev.jquery.com/browser/trunk/jquery/MIT-LICENSE.txt) licenses.
+ *
+ * @version     1.1.x
+ * @author      Nuno Fernandes
+ *              Matthew Lohbihler
+ * @url         www.codingwithcoffee.com
+ * @inspiration Localisation assistance for jQuery (http://keith-wood.name/localisation.html)
+ *              by Keith Wood (kbwood{at}iinet.com.au) June 2007
+ *
+ *****************************************************************************/
diff --git a/specs/pki-core.spec b/specs/pki-core.spec
index 66b2962..15f9850 100644
--- a/specs/pki-core.spec
+++ b/specs/pki-core.spec
@@ -5,7 +5,7 @@ distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
 
 Name:             pki-core
 Version:          10.0.0
-Release:          4%{?dist}
+Release:          5%{?dist}
 Summary:          Certificate System - PKI Core Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -834,6 +834,7 @@ fi
 
 %files -n pki-server
 %defattr(-,root,root,-)
+%doc base/common/THIRD_PARTY_LICENSES
 %doc base/deploy/LICENSE
 %{_sysconfdir}/pki/
 %{_sbindir}/pkispawn
@@ -984,6 +985,9 @@ fi
 
 
 %changelog
+* Wed Jan  9 2013 Matthew Harmsen <mharmsen@redhat.com> 10.0.0-5
+- TRAC Ticket #430 - License for 3rd party code
+
 * Fri Jan  4 2013 Matthew Harmsen <mharmsen@redhat.com> 10.0.0-4
 - TRAC Ticket #469 - Dogtag 10: Fix tomcatjss issue in pki-core.spec and
   dogtag-pki.spec . . .
-- 
1.7.12.1