From db9288970860af689cb06aad23a51c04e63b7c96 Mon Sep 17 00:00:00 2001
From: Matthew Harmsen <mharmsen@redhat.com>
Date: Wed, 27 Aug 2014 14:06:47 -0700
Subject: [PATCH] Disable PKI GUI Configuration

- PKI TRAC Ticket #1120 - Remove Firefox PKI GUI Configuration Panel Interface
---
 base/ca/shared/webapps/ca/WEB-INF/web.xml          | 36 --------------------
 base/kra/shared/webapps/kra/WEB-INF/web.xml        | 38 ----------------------
 base/ocsp/shared/webapps/ocsp/WEB-INF/web.xml      | 37 ---------------------
 base/server/man/man5/pki_default.cfg.5             |  8 -----
 base/server/man/man8/pkispawn.8                    | 16 +--------
 .../python/pki/server/deployment/pkihelper.py      | 19 -----------
 .../python/pki/server/deployment/pkimessages.py    |  9 -----
 .../python/pki/server/deployment/pkiparser.py      | 15 ---------
 .../server/deployment/scriptlets/finalization.py   |  4 ---
 base/server/sbin/pkispawn                          |  6 ++--
 base/tks/shared/webapps/tks/WEB-INF/web.xml        | 37 ---------------------
 base/tps-tomcat/shared/webapps/tps/WEB-INF/web.xml | 36 --------------------
 12 files changed, 4 insertions(+), 257 deletions(-)

diff --git a/base/ca/shared/webapps/ca/WEB-INF/web.xml b/base/ca/shared/webapps/ca/WEB-INF/web.xml
index 508c316..9a03674 100644
--- a/base/ca/shared/webapps/ca/WEB-INF/web.xml
+++ b/base/ca/shared/webapps/ca/WEB-INF/web.xml
@@ -5,32 +5,6 @@
 
     <display-name>Certificate Authority</display-name>
 
-    <servlet>
-        <servlet-name>csadmin-wizard</servlet-name>
-        <servlet-class>com.netscape.cms.servlet.wizard.WizardServlet</servlet-class>
-        <init-param>
-            <param-name>properties</param-name>
-            <param-value>/WEB-INF/velocity.properties</param-value>
-        </init-param>
-        <init-param>
-            <param-name>name</param-name>
-            <param-value>CA Setup Wizard</param-value>
-        </init-param>
-        <init-param>
-            <param-name>panels</param-name>
-            <param-value>welcome=com.netscape.cms.servlet.csadmin.WelcomePanel,module=com.netscape.cms.servlet.csadmin.ModulePanel,confighsmlogin=com.netscape.cms.servlet.csadmin.ConfigHSMLoginPanel,securitydomain=com.netscape.cms.servlet.csadmin.SecurityDomainPanel,securitydomain=com.netscape.cms.servlet.csadmin.DisplayCertChainPanel,subsystem=com.netscape.cms.servlet.csadmin.CreateSubsystemPanel,clone=com.netscape.cms.servlet.csadmin.DisplayCertChainPanel,restorekeys=com.netscape.cms.servlet.csadmin.RestoreKeyCertPanel,cahierarchy=com.netscape.cms.servlet.csadmin.HierarchyPanel,database=com.netscape.cms.servlet.csadmin.DatabasePanel,size=com.netscape.cms.servlet.csadmin.SizePanel,subjectname=com.netscape.cms.servlet.csadmin.NamePanel,certrequest=com.netscape.cms.servlet.csadmin.CertRequestPanel,backupkeys=com.netscape.cms.servlet.csadmin.BackupKeyCertPanel,savepk12=com.netscape.cms.servlet.csadmin.SavePKCS12Panel,importcachain=com.netscape.cms.servlet.csadmin.ImportCAChainPanel,admin=com.netscape.cms.servlet.csadmin.AdminPanel,importadmincert=com.netscape.cms.servlet.csadmin.ImportAdminCertPanel,done=com.netscape.cms.servlet.csadmin.DonePanel</param-value>
-        </init-param>
-    </servlet>
-
-    <servlet>
-        <servlet-name>csadmin-login</servlet-name>
-        <servlet-class>com.netscape.cms.servlet.csadmin.LoginServlet</servlet-class>
-        <init-param>
-            <param-name>properties</param-name>
-            <param-value>/WEB-INF/velocity.properties</param-value>
-        </init-param>
-    </servlet>
-
    <servlet>
       <servlet-name>  services </servlet-name>
       <servlet-class> com.netscape.cms.servlet.csadmin.MainPageServlet </servlet-class>
@@ -2312,16 +2286,6 @@
       <url-pattern>   /ee/ca/doRevoke  </url-pattern>
    </servlet-mapping>
 
-    <servlet-mapping>
-        <servlet-name>csadmin-login</servlet-name>
-        <url-pattern>/admin/console/config/login</url-pattern>
-    </servlet-mapping>
-
-    <servlet-mapping>
-        <servlet-name>csadmin-wizard</servlet-name>
-        <url-pattern>/admin/console/config/wizard</url-pattern>
-    </servlet-mapping>
-
    <servlet-mapping>
       <servlet-name>  caUpdateConnector </servlet-name>
       <url-pattern>   /admin/ca/updateConnector  </url-pattern>
diff --git a/base/kra/shared/webapps/kra/WEB-INF/web.xml b/base/kra/shared/webapps/kra/WEB-INF/web.xml
index d0573d5..ce0a51e 100644
--- a/base/kra/shared/webapps/kra/WEB-INF/web.xml
+++ b/base/kra/shared/webapps/kra/WEB-INF/web.xml
@@ -5,33 +5,6 @@
 
     <display-name>Key Recovery Authority</display-name>
 
-    <servlet>
-        <servlet-name>csadmin-wizard</servlet-name>
-        <servlet-class>com.netscape.cms.servlet.wizard.WizardServlet</servlet-class>
-        <init-param>
-            <param-name>properties</param-name>
-            <param-value>/WEB-INF/velocity.properties</param-value>
-        </init-param>
-        <init-param>
-            <param-name>name</param-name>
-            <param-value>DRM Setup Wizard</param-value>
-        </init-param>
-        <init-param>
-            <param-name>panels</param-name>
-            <param-value>welcome=com.netscape.cms.servlet.csadmin.WelcomePanel,module=com.netscape.cms.servlet.csadmin.ModulePanel,confighsmlogin=com.netscape.cms.servlet.csadmin.ConfigHSMLoginPanel,securitydomain=com.netscape.cms.servlet.csadmin.SecurityDomainPanel,securitydomain=com.netscape.cms.servlet.csadmin.DisplayCertChainPanel,subsystem=com.netscape.cms.servlet.csadmin.CreateSubsystemPanel,restorekeys=com.netscape.cms.servlet.csadmin.RestoreKeyCertPanel,databasepanel=com.netscape.cms.servlet.csadmin.DatabasePanel,sizepanel=com.netscape.cms.servlet.csadmin.SizePanel,namepanel=com.netscape.cms.servlet.csadmin.NamePanel,certrequestpanel=com.netscape.cms.servlet.csadmin.CertRequestPanel,backupkeys=com.netscape.cms.servlet.csadmin.BackupKeyCertPanel,savepk12=com.netscape.cms.servlet.csadmin.SavePKCS12Panel,adminpanel=com.netscape.cms.servlet.csadmin.AdminPanel,importadmincertpanel=com.netscape.cms.servlet.csadmin.ImportAdminCertPanel,donepanel=com.netscape.cms.servlet.csadmin.DonePanel</param-value>
-        </init-param>
-    </servlet>
-
-    <servlet>
-        <servlet-name>csadmin-login</servlet-name>
-        <servlet-class>com.netscape.cms.servlet.csadmin.LoginServlet</servlet-class>
-        <init-param>
-            <param-name>properties</param-name>
-            <param-value>/WEB-INF/velocity.properties</param-value>
-        </init-param>
-    </servlet>
-
-
    <servlet>
       <servlet-name>  kraKRADisplayBySerialForRecovery  </servlet-name>
       <servlet-class> com.netscape.cms.servlet.key.DisplayBySerialForRecovery  </servlet-class>
@@ -1010,12 +983,6 @@
       <url-pattern>   /agent/kra/displayBySerial  </url-pattern>
    </servlet-mapping>
 
-    <servlet-mapping>
-        <servlet-name>csadmin-login</servlet-name>
-        <url-pattern>/admin/console/config/login</url-pattern>
-    </servlet-mapping>
-
-
    <servlet-mapping>
       <servlet-name>  kraRegisterUser </servlet-name>
       <url-pattern>   /admin/kra/registerUser  </url-pattern>
@@ -1026,11 +993,6 @@
       <url-pattern>   /admin/kra/getTransportCert  </url-pattern>
    </servlet-mapping>
 
-    <servlet-mapping>
-        <servlet-name>csadmin-wizard</servlet-name>
-        <url-pattern>/admin/console/config/wizard</url-pattern>
-    </servlet-mapping>
-
    <servlet-mapping>
       <servlet-name>  kraGetConfigEntries  </servlet-name>
       <url-pattern>   /admin/kra/getConfigEntries  </url-pattern>
diff --git a/base/ocsp/shared/webapps/ocsp/WEB-INF/web.xml b/base/ocsp/shared/webapps/ocsp/WEB-INF/web.xml
index 21067d7..b8eccf1 100644
--- a/base/ocsp/shared/webapps/ocsp/WEB-INF/web.xml
+++ b/base/ocsp/shared/webapps/ocsp/WEB-INF/web.xml
@@ -9,33 +9,6 @@
 
     <display-name>Online Certificate Status Protocol Manager</display-name>
 
-    <servlet>
-        <servlet-name>csadmin-wizard</servlet-name>
-        <servlet-class>com.netscape.cms.servlet.wizard.WizardServlet</servlet-class>
-        <init-param>
-            <param-name>properties</param-name>
-            <param-value>/WEB-INF/velocity.properties</param-value>
-        </init-param>
-        <init-param>
-            <param-name>name</param-name>
-            <param-value>OCSP Setup Wizard</param-value>
-        </init-param>
-        <init-param>
-            <param-name>panels</param-name>
-            <param-value>welcome=com.netscape.cms.servlet.csadmin.WelcomePanel,module=com.netscape.cms.servlet.csadmin.ModulePanel,confighsmlogin=com.netscape.cms.servlet.csadmin.ConfigHSMLoginPanel,securitydomain=com.netscape.cms.servlet.csadmin.SecurityDomainPanel,securitydomain=com.netscape.cms.servlet.csadmin.DisplayCertChainPanel,subsystem=com.netscape.cms.servlet.csadmin.CreateSubsystemPanel,restorekeys=com.netscape.cms.servlet.csadmin.RestoreKeyCertPanel,databasepanel=com.netscape.cms.servlet.csadmin.DatabasePanel,sizepanel=com.netscape.cms.servlet.csadmin.SizePanel,namepanel=com.netscape.cms.servlet.csadmin.NamePanel,certrequestpanel=com.netscape.cms.servlet.csadmin.CertRequestPanel,backupkeys=com.netscape.cms.servlet.csadmin.BackupKeyCertPanel,savepk12=com.netscape.cms.servlet.csadmin.SavePKCS12Panel,adminpanel=com.netscape.cms.servlet.csadmin.AdminPanel,importadmincertpanel=com.netscape.cms.servlet.csadmin.ImportAdminCertPanel,donepanel=com.netscape.cms.servlet.csadmin.DonePanel</param-value>
-        </init-param>
-    </servlet>
-
-    <servlet>
-        <servlet-name>csadmin-login</servlet-name>
-        <servlet-class>com.netscape.cms.servlet.csadmin.LoginServlet</servlet-class>
-        <init-param>
-            <param-name>properties</param-name>
-            <param-value>/WEB-INF/velocity.properties</param-value>
-        </init-param>
-    </servlet>
-
-
    <servlet>
       <servlet-name>  ocspacl  </servlet-name>
       <servlet-class> com.netscape.cms.servlet.admin.ACLAdminServlet  </servlet-class>
@@ -659,16 +632,6 @@
       <url-pattern>   /ee/ocsp/*  </url-pattern>
    </servlet-mapping>
                                                                                 
-    <servlet-mapping>
-        <servlet-name>csadmin-wizard</servlet-name>
-        <url-pattern>/admin/console/config/wizard</url-pattern>
-    </servlet-mapping>
-                                                                                
-    <servlet-mapping>
-        <servlet-name>csadmin-login</servlet-name>
-        <url-pattern>/admin/console/config/login</url-pattern>
-    </servlet-mapping>
-
    <servlet-mapping>
       <servlet-name>  ocspGetConfigEntries  </servlet-name>
       <url-pattern>   /admin/ocsp/getConfigEntries  </url-pattern>
diff --git a/base/server/man/man5/pki_default.cfg.5 b/base/server/man/man5/pki_default.cfg.5
index 040eb1b..c4e1f13 100644
--- a/base/server/man/man5/pki_default.cfg.5
+++ b/base/server/man/man5/pki_default.cfg.5
@@ -190,14 +190,6 @@ Hostname and port, or URI of the issuing CA.  Required for installations of subo
 .IP
 Sets whether to restart the instance after configuration is complete.  Defaults to True.
 .PP
-.B pki_skip_configuration
-.IP
-Sets whether to execute the configuration steps when running \fBpkispawn\fP.  If this is true, then the process is analogous to running \fBpkicreate\fP, when the configuration was performed separately from the instance creation.  A configuration URL will be provided.  This URL can be used as a starting point for the browser-based configuration panels.  Defaults to False.
-.PP
-.B pki_skip_installation
-.IP
-Sets whether to skip the installation steps.  With pki_skip_configuration set to False, this is analogous to running pkisilent.  Defaults to False.
-.PP
 .B pki_enable_access_log
 .IP
 Located in the [Tomcat] section, this variable determines whether the instance will enable (True) or disable (False) Tomcat access logging.  Defaults to True.
diff --git a/base/server/man/man8/pkispawn.8 b/base/server/man/man8/pkispawn.8
index ebed2cb..d09d7d4 100644
--- a/base/server/man/man8/pkispawn.8
+++ b/base/server/man/man8/pkispawn.8
@@ -65,23 +65,9 @@ Instances created using \fBpkispawn\fP can be removed using \fBpkidestroy\fP.  S
 .BR pkidestroy(8).
 .PP
 \fBpkispawn\fP supersedes and combines the functionality of \fBpkicreate\fP and \fBpkisilent\fP, which were available in earlier releases of Certificate Server.  It is now possible to completely create and configure the Certificate Server subsystem in a single step using \fBpkispawn\fP.
- 
-.PP
-Although \fBpkispawn\fP can be used to install and configure an instance in a single invocation, it can also still be directed to split this work into separate 'installation' and 'configuration' tasks (e. g. - to support an organization's policy where 'installation' and 'configuration' tasks must be fulfilled by separate roles).
-
-.PP
-To run \fBpkispawn\fP for instance installation only, leave the configuration parameter \fBpki_skip_installation\fP set to False (the default), and set the configuration parameter \fBpki_skip_configuration\fP to True. This instance must then be configured using either a \fBpkispawn\fP command line interface (CLI) configuration, or a browser-based (GUI) configuration.
-
-.PP
-To configure an instance using the CLI-based configuration, set the configuration parameter \fBpki_skip_installation\fP to True, leave the configuration parameter \fBpki_skip_configuration\fP to False (the default), and run \fBpkispawn\fP for configuration only.
-
-.PP
-To configure an instance using the GUI-based configuration, launch a browser, input the configuration URL located inside the \fI/var/log/pki/pki-<subsystem>-spawn.<timestamp>.log\fP file, and fill-in the desired/required information for each panel.  The final panel will instruct the user to restart the server.
-
 .TP
 \fBNote:\fP 
-CLI-based configuration and GUI-based configuration go through different code. There is additional code in the CLI-based configuration to support instances that contain more than one subsystem; the GUI-based configuration does not contain this code.  Consequently, GUI-based configuration must not be used to configure a PKI instance which contains more than one subsystem.
-
+Previously, as an alternative to using \fBpkisilent\fP to perform a non-interactive batch configuration, a PKI instance could be interactively configured by a GUI-based configuration wizard via a Firefox browser.  GUI-based configuration of a PKI instance is unavailable in this version of the product.
 .SH OPTIONS
 .TP
 .B -s <subsystem>
diff --git a/base/server/python/pki/server/deployment/pkihelper.py b/base/server/python/pki/server/deployment/pkihelper.py
index 148dab0..823a207 100644
--- a/base/server/python/pki/server/deployment/pkihelper.py
+++ b/base/server/python/pki/server/deployment/pkihelper.py
@@ -469,25 +469,6 @@ class ConfigurationFile:
         # set useful 'string' object variables for this class
         self.subsystem = self.mdict['pki_subsystem']
 
-    def log_configuration_url(self):
-        # NOTE:  This is the one and only parameter containing a sensitive
-        #        parameter that may be stored in a log file.
-        config.pki_log.info(log.PKI_CONFIGURATION_WIZARD_URL_1,
-                            self.mdict['pki_configuration_url'],
-                            extra=config.PKI_INDENTATION_LEVEL_2)
-        config.pki_log.info(log.PKI_CONFIGURATION_WIZARD_RESTART_1,
-                            self.mdict['pki_registry_initscript_command'],
-                            extra=config.PKI_INDENTATION_LEVEL_2)
-
-    def display_configuration_url(self):
-        # NOTE:  This is the one and only parameter containing a sensitive
-        #        parameter that may be displayed to the screen.
-        print log.PKI_CONFIGURATION_URL_1 % self.mdict['pki_configuration_url']
-        print
-        print log.PKI_CONFIGURATION_RESTART_1 % \
-            self.mdict['pki_registry_initscript_command']
-        print
-
     def confirm_external(self):
         # ALWAYS defined via 'pkiparser.py'
         if self.external:
diff --git a/base/server/python/pki/server/deployment/pkimessages.py b/base/server/python/pki/server/deployment/pkimessages.py
index 405118a..8b5ce3f 100644
--- a/base/server/python/pki/server/deployment/pkimessages.py
+++ b/base/server/python/pki/server/deployment/pkimessages.py
@@ -61,19 +61,10 @@ VERBOSITY FLAGS    CONSOLE MESSAGE LEVEL       LOG MESSAGE LEVEL
 
 # PKI Deployment Error Messages
 PKI_BADZIPFILE_ERROR_1 = "zipfile.BadZipFile:  %s!"
-PKI_CONFIGURATION_RESTART_1 = '''
-    After configuration, the server can be operated by the command:
-        %s
-'''
 PKI_CONFIGURATION_STANDALONE_1 = '''
       Please obtain the necessary certificates for this stand-alone %s,
       and re-run the configuration for step two.
 '''
-PKI_CONFIGURATION_URL_1 = \
-    "    Please start the configuration by accessing:\n    %s"
-PKI_CONFIGURATION_WIZARD_RESTART_1 = \
-    "After configuration, the server can be operated by the command:\n%s"
-PKI_CONFIGURATION_WIZARD_URL_1 = "Configuration Wizard listening on\n%s"
 PKI_DIRECTORY_ALREADY_EXISTS_1 = "Directory '%s' already exists!"
 PKI_DIRECTORY_ALREADY_EXISTS_NOT_A_DIRECTORY_1 = \
     "Directory '%s' already exists BUT it is NOT a directory!"
diff --git a/base/server/python/pki/server/deployment/pkiparser.py b/base/server/python/pki/server/deployment/pkiparser.py
index 1d201ce..3b2a99c 100644
--- a/base/server/python/pki/server/deployment/pkiparser.py
+++ b/base/server/python/pki/server/deployment/pkiparser.py
@@ -1209,21 +1209,6 @@ class PKIConfigParser:
                 self.mdict['pki_subsystem_archive_log_path'] + "/" + \
                 "spawn" + "_" + "manifest" + "." + \
                 self.mdict['pki_timestamp']
-            # Construct the configuration URL containing the one-time pin
-            # and add this to the "sensitive" key value pairs read in from
-            # the configuration file
-            #
-            # NOTE:  This is the one and only parameter containing a sensitive
-            #        parameter that may be stored in a log file and displayed
-            #        to the screen.
-            #
-            self.mdict['pki_configuration_url'] = \
-                "https://{}:{}/{}/{}?pin={}".format(
-                    self.mdict['pki_hostname'],
-                    self.mdict['pki_https_port'],
-                    self.mdict['pki_subsystem'].lower(),
-                    "admin/console/config/login",
-                    self.mdict['pki_one_time_pin'])
             # Compose this "systemd" execution management command
             if self.mdict['pki_subsystem'] in\
                config.PKI_APACHE_SUBSYSTEMS:
diff --git a/base/server/python/pki/server/deployment/scriptlets/finalization.py b/base/server/python/pki/server/deployment/scriptlets/finalization.py
index d3756b7..c545642 100644
--- a/base/server/python/pki/server/deployment/scriptlets/finalization.py
+++ b/base/server/python/pki/server/deployment/scriptlets/finalization.py
@@ -71,10 +71,6 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                     deployer.mdict['pki_client_subsystem_dir']):
                 deployer.directory.delete(
                     deployer.mdict['pki_client_subsystem_dir'])
-        # If instance has not been configured, print the
-        # configuration URL to the log
-        if config.str2bool(deployer.mdict['pki_skip_configuration']):
-            deployer.configuration_file.log_configuration_url()
         # Log final process messages
         config.pki_log.info(log.PKISPAWN_END_MESSAGE_2,
                             deployer.mdict['pki_subsystem'],
diff --git a/base/server/sbin/pkispawn b/base/server/sbin/pkispawn
index 2f41afc..4b93974 100755
--- a/base/server/sbin/pkispawn
+++ b/base/server/sbin/pkispawn
@@ -536,9 +536,9 @@ def print_install_information(mdict):
     skip_configuration = config.str2bool(mdict['pki_skip_configuration'])
     print log.PKI_SPAWN_INFORMATION_HEADER
     if skip_configuration:
-        print log.PKI_CONFIGURATION_URL_1 % mdict['pki_configuration_url']
-        print log.PKI_CONFIGURATION_RESTART_1 % \
-            mdict['pki_registry_initscript_command']
+        print "      The %s subsystem of the '%s' instance\n" \
+              "      must still be configured!" % \
+              (config.pki_subsystem, mdict['pki_instance_name'])
     else:
         print "      Administrator's username:             %s" % \
               mdict['pki_admin_uid']
diff --git a/base/tks/shared/webapps/tks/WEB-INF/web.xml b/base/tks/shared/webapps/tks/WEB-INF/web.xml
index 0642fae..2d4c029 100644
--- a/base/tks/shared/webapps/tks/WEB-INF/web.xml
+++ b/base/tks/shared/webapps/tks/WEB-INF/web.xml
@@ -9,32 +9,6 @@
 
     <display-name>Token Key Service</display-name>
 
-    <servlet>
-        <servlet-name>csadmin-wizard</servlet-name>
-        <servlet-class>com.netscape.cms.servlet.wizard.WizardServlet</servlet-class>
-        <init-param>
-            <param-name>properties</param-name>
-            <param-value>/WEB-INF/velocity.properties</param-value>
-        </init-param>
-        <init-param>
-            <param-name>name</param-name>
-            <param-value>TKS Setup Wizard</param-value>
-        </init-param>
-        <init-param>
-            <param-name>panels</param-name>
-            <param-value>welcome=com.netscape.cms.servlet.csadmin.WelcomePanel,module=com.netscape.cms.servlet.csadmin.ModulePanel,confighsmlogin=com.netscape.cms.servlet.csadmin.ConfigHSMLoginPanel,securitydomain=com.netscape.cms.servlet.csadmin.SecurityDomainPanel,securitydomain=com.netscape.cms.servlet.csadmin.DisplayCertChainPanel,subsystem=com.netscape.cms.servlet.csadmin.CreateSubsystemPanel,restorekeys=com.netscape.cms.servlet.csadmin.RestoreKeyCertPanel,databasepanel=com.netscape.cms.servlet.csadmin.DatabasePanel,sizepanel=com.netscape.cms.servlet.csadmin.SizePanel,namepanel=com.netscape.cms.servlet.csadmin.NamePanel,certrequestpanel=com.netscape.cms.servlet.csadmin.CertRequestPanel,backupkeys=com.netscape.cms.servlet.csadmin.BackupKeyCertPanel,savepk12=com.netscape.cms.servlet.csadmin.SavePKCS12Panel,adminpanel=com.netscape.cms.servlet.csadmin.AdminPanel,importadmincertpanel=com.netscape.cms.servlet.csadmin.ImportAdminCertPanel,donepanel=com.netscape.cms.servlet.csadmin.DonePanel</param-value>
-        </init-param>
-    </servlet>
-
-    <servlet>
-        <servlet-name>csadmin-login</servlet-name>
-        <servlet-class>com.netscape.cms.servlet.csadmin.LoginServlet</servlet-class>
-        <init-param>
-            <param-name>properties</param-name>
-            <param-value>/WEB-INF/velocity.properties</param-value>
-        </init-param>
-    </servlet>
-
    <servlet>
       <servlet-name>  tksstart  </servlet-name>
       <servlet-class> com.netscape.cms.servlet.base.CMSStartServlet  </servlet-class>
@@ -359,17 +333,6 @@
       <url-pattern>   /agent/tks/computeRandomData  </url-pattern>
    </servlet-mapping>
 
-                                                                                
-    <servlet-mapping>
-        <servlet-name>csadmin-wizard</servlet-name>
-        <url-pattern>/admin/console/config/wizard</url-pattern>
-    </servlet-mapping>
-                                                                                
-    <servlet-mapping>
-        <servlet-name>csadmin-login</servlet-name>
-        <url-pattern>/admin/console/config/login</url-pattern>
-    </servlet-mapping>
-
    <servlet-mapping>
       <servlet-name>  tksGetConfigEntries  </servlet-name>
       <url-pattern>   /admin/tks/getConfigEntries  </url-pattern>
diff --git a/base/tps-tomcat/shared/webapps/tps/WEB-INF/web.xml b/base/tps-tomcat/shared/webapps/tps/WEB-INF/web.xml
index 66bc303..8506b27 100644
--- a/base/tps-tomcat/shared/webapps/tps/WEB-INF/web.xml
+++ b/base/tps-tomcat/shared/webapps/tps/WEB-INF/web.xml
@@ -10,32 +10,6 @@
     <display-name>Token Processing Service</display-name>
 
     <servlet>
-        <servlet-name>csadmin-wizard</servlet-name>
-        <servlet-class>com.netscape.cms.servlet.wizard.WizardServlet</servlet-class>
-        <init-param>
-            <param-name>properties</param-name>
-            <param-value>/WEB-INF/velocity.properties</param-value>
-        </init-param>
-        <init-param>
-            <param-name>name</param-name>
-            <param-value>CA Setup Wizard</param-value>
-        </init-param>
-        <init-param>
-            <param-name>panels</param-name>
-            <param-value>welcome=com.netscape.cms.servlet.csadmin.WelcomePanel,module=com.netscape.cms.servlet.csadmin.ModulePanel,confighsmlogin=com.netscape.cms.servlet.csadmin.ConfigHSMLoginPanel,securitydomain=com.netscape.cms.servlet.csadmin.SecurityDomainPanel,securitydomain=com.netscape.cms.servlet.csadmin.DisplayCertChainPanel,subsystem=com.netscape.cms.servlet.csadmin.CreateSubsystemPanel,clone=com.netscape.cms.servlet.csadmin.DisplayCertChainPanel,restorekeys=com.netscape.cms.servlet.csadmin.RestoreKeyCertPanel,cainfopanel=org.dogtagpki.server.tps.installer.CAInfoPanel,tksinfopanel=org.dogtagpki.server.tps.installer.TKSInfoPanel,drminfopanel=org.dogtagpki.server.tps.installer.DRMInfoPanel,authdbpanel=com.netscape.cms.servlet.csadmin.AuthDBPanel,database=com.netscape.cms.servlet.csadmin.DatabasePanel,size=com.netscape.cms.servlet.csadmin.SizePanel,subjectname=com.netscape.cms.servlet.csadmin.NamePanel,certrequest=com.netscape.cms.servlet.csadmin.CertRequestPanel,backupkeys=com.netscape.cms.servlet.csadmin.BackupKeyCertPanel,savepk12=com.netscape.cms.servlet.csadmin.SavePKCS12Panel,importcachain=com.netscape.cms.servlet.csadmin.ImportCAChainPanel,admin=com.netscape.cms.servlet.csadmin.AdminPanel,importadmincert=com.netscape.cms.servlet.csadmin.ImportAdminCertPanel,done=com.netscape.cms.servlet.csadmin.DonePanel</param-value>
-        </init-param>
-    </servlet>
-
-    <servlet>
-        <servlet-name>csadmin-login</servlet-name>
-        <servlet-class>com.netscape.cms.servlet.csadmin.LoginServlet</servlet-class>
-        <init-param>
-            <param-name>properties</param-name>
-            <param-value>/WEB-INF/velocity.properties</param-value>
-        </init-param>
-    </servlet>
-
-    <servlet>
         <servlet-name>tpsstart</servlet-name>
         <servlet-class>com.netscape.cms.servlet.base.CMSStartServlet</servlet-class>
         <init-param>
@@ -145,16 +119,6 @@
     </servlet-mapping>
 
     <servlet-mapping>
-        <servlet-name>csadmin-login</servlet-name>
-        <url-pattern>/admin/console/config/login</url-pattern>
-    </servlet-mapping>
-
-    <servlet-mapping>
-        <servlet-name>csadmin-wizard</servlet-name>
-        <url-pattern>/admin/console/config/wizard</url-pattern>
-    </servlet-mapping>
-
-    <servlet-mapping>
         <servlet-name>tpsGetStatus</servlet-name>
         <url-pattern>/admin/tps/getStatus</url-pattern>
     </servlet-mapping>
-- 
1.9.3